<?xml version="1.0" encoding="utf-8"?>
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:tools="http://schemas.android.com/tools"
    package="info.guardianproject.keanuapp"
    android:installLocation="auto"
    android:sharedUserLabel="@string/perm_label"
    android:usesCleartextTraffic="false">

    <supports-screens
        android:anyDensity="true"
        android:largeScreens="true"
        android:normalScreens="true"
        android:smallScreens="true" />

    <uses-permission android:name="android.permission.VIBRATE" />
    <uses-permission android:name="android.permission.INTERNET" />
    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
    <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE" />
    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
    <uses-permission android:name="android.permission.RECEIVE_BOOT_COMPLETED" />
    <uses-permission android:name="android.permission.RECORD_AUDIO" />
    <uses-permission android:name="android.permission.CAMERA" />
    <uses-permission
        android:name="android.permission.READ_PHONE_STATE"
        android:required="false" />
    <uses-permission android:name="android.permission.MODIFY_AUDIO_SETTINGS" />
    <uses-permission android:name="android.permission.REQUEST_IGNORE_BATTERY_OPTIMIZATIONS" /> <!-- Required for Nearby Connections -->
    <uses-permission android:name="android.permission.BLUETOOTH" />
    <uses-permission android:name="android.permission.BLUETOOTH_ADMIN" />
    <uses-permission android:name="android.permission.ACCESS_WIFI_STATE" />
    <uses-permission android:name="android.permission.CHANGE_WIFI_STATE" />
    <uses-permission android:name="android.permission.ACCESS_COARSE_LOCATION" />
    <uses-permission android:name="android.permission.FOREGROUND_SERVICE" />
    <!--
     Some Chromebooks don't support touch. Although not essential,
     it's a good idea to explicitly include this declaration.
    -->
    <uses-feature
        android:name="android.hardware.touchscreen"
        android:required="false" />
    <uses-feature
        android:name="android.hardware.camera"
        android:required="false" />
    <uses-feature
        android:name="android.hardware.camera.autofocus"
        android:required="false" />
    <uses-feature
        android:name="android.hardware.telephony"
        android:required="false" />
    <uses-feature
        android:name="android.hardware.microphone"
        android:required="false" />
    <!--
         Some Chromebooks don't support touch. Although not essential,
            it's a good idea to explicitly include this declaration.
    -->
    <uses-feature
        android:name="android.hardware.wifi"
        android:required="false" />

    <permission
        android:name="${applicationId}.core.permission.IM_SERVICE"
        android:description="@string/perm_desc"
        android:label="@string/perm_label"
        android:permissionGroup="android.permission-group.MESSAGES"
        android:protectionLevel="dangerous" />
    <permission
        android:name="${applicationId}.core.permission.READ_ONLY"
        android:description="@string/ro_perm_desc"
        android:label="@string/ro_perm_label"
        android:permissionGroup="android.permission-group.MESSAGES"
        android:protectionLevel="dangerous" />
    <permission
        android:name="${applicationId}.core.permission.WRITE_ONLY"
        android:description="@string/wo_perm_desc"
        android:label="@string/wo_perm_label"
        android:permissionGroup="android.permission-group.MESSAGES"
        android:protectionLevel="dangerous" />

    <application
        android:name=".ImApp"
        android:allowBackup="false"
        android:icon="@mipmap/ic_launcher"
        android:label="@string/ic_launcher_name"
        android:largeHeap="true"
        android:hardwareAccelerated="true"
        android:theme="@style/AppTheme"
        tools:replace="android:allowBackup,android:label">
        <activity android:name=".ui.conversation.StoryIntroActivity"></activity>
        <activity
            android:name=".RouterActivity"
            android:theme="@style/InviteDialog">
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />

                <category android:name="android.intent.category.LAUNCHER" />
            </intent-filter>
            <intent-filter>
                <action android:name="info.guardianproject.panic.action.TRIGGER" />

                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.SEND" />

                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="android.intent.category.ALTERNATIVE" />
                <category android:name="android.intent.category.SELECTED_ALTERNATIVE" />

                <data android:mimeType="*/*" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />

                <category android:name="android.intent.category.BROWSABLE" />
                <category android:name="android.intent.category.DEFAULT" />

                <data android:scheme="keanu" />
                <data android:scheme="matrix" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />

                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="android.intent.category.BROWSABLE" />

                <data
                    android:host="matrix.to"
                    android:pathPrefix="/#/"
                    android:scheme="https" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />

                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="android.intent.category.BROWSABLE" />

                <data
                    android:host="keanu.im"
                    android:pathPrefix="/i/"
                    android:scheme="https" />
            </intent-filter>
        </activity>
        <activity
            android:name=".MainActivity"
            android:exported="true"
            android:launchMode="singleTask"
            android:theme="@style/AppThemeNoAction">
            <intent-filter tools:ignore="AppLinkUrlError">
                <action android:name="android.intent.action.VIEW" />

                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="info.guardianproject.otr.app.im.IMPS_CATEGORY" />

                <data android:mimeType="vnd.android.cursor.item/imps-chats" />
            </intent-filter>
            <intent-filter tools:ignore="AppLinkUrlError">
                <action android:name="android.intent.action.VIEW" />

                <category android:name="android.intent.category.DEFAULT" />

                <data android:mimeType="vnd.android.cursor.item/imps-invitations" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.IM_MANAGE_SUBSCRIPTION" />

                <category android:name="android.intent.category.DEFAULT" />

                <data android:mimeType="vnd.android.cursor.item/imps-contacts" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ImUrlActivity"
            android:theme="@style/InviteDialog" />
        <activity
            android:name=".ui.legacy.SignoutActivity"
            android:exported="false">
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />

                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ui.contacts.AddContactActivity"
            android:exported="false"
            android:label="@string/add_friends" />
        <activity
            android:name=".ui.contacts.ContactsPickerActivity"
            android:exported="false"
            android:label="@string/choose_friend">
            <intent-filter>
                <action android:name="android.intent.action.PICK" />

                <category android:name="android.intent.category.DEFAULT" />

                <data android:mimeType="vnd.android.cursor.dir/imps-contacts" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.PICK" />

                <category android:name="android.intent.category.DEFAULT" />

                <data android:mimeType="vnd.android.cursor.dir/imps-chats" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ui.accounts.AccountActivity"
            android:exported="false"
            android:windowSoftInputMode="stateUnchanged">
            <intent-filter>
                <action android:name="android.intent.action.EDIT" />

                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="${applicationId}.core.service.IMPS_CATEGORY" />

                <data android:mimeType="vnd.android.cursor.item/imps-accounts" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.INSERT" />

                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="${applicationId}.core.service.IMPS_CATEGORY" />

                <data android:mimeType="vnd.android.cursor.item/imps-providers" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ui.accounts.AccountSettingsActivity"
            android:exported="false">
            <intent-filter>
                <action android:name="android.intent.action.PICK" />

                <category android:name="${applicationId}.core.service.IMPS_CATEGORY" />
                <category android:name="android.intent.category.DEFAULT" />

                <data android:mimeType="vnd.android-dir/imps-providersettings" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ui.legacy.SettingActivity"
            android:exported="false">
            <intent-filter>
                <action android:name="android.intent.action.PICK" />

                <category android:name="${applicationId}.core.service.IMPS_CATEGORY" />
                <category android:name="android.intent.category.DEFAULT" />

                <data android:mimeType="vnd.android-dir/imps-providersettings" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ui.LockScreenActivity"
            android:label="@string/title_activity_lock_screen" />
        <activity
            android:name=".ui.onboarding.OnboardingActivity"
            android:configChanges="keyboardHidden|orientation|screenSize"
            android:launchMode="singleTask" />
        <activity
            android:name=".ui.qr.QrScanActivity"
            android:configChanges="keyboardHidden|orientation|screenSize" />
        <activity
            android:name=".ui.qr.QrDisplayActivity"
            android:configChanges="keyboardHidden|orientation|screenSize" />
        <activity
            android:name=".ui.widgets.ImageViewActivity"
            android:exported="false"
            android:theme="@style/AppTheme.Transparent" />
        <activity
            android:name=".ui.widgets.PdfViewActivity"
            android:theme="@style/AppTheme.Transparent"
            android:exported="false" />
        <activity
            android:name=".ui.widgets.WebViewActivity"
            android:theme="@style/AppTheme.Transparent"
            android:exported="false" />
        <activity
            android:name=".ui.widgets.VideoViewActivity"
            android:theme="@style/AppTheme.Transparent"
            android:exported="false" />
        <activity android:name=".ui.widgets.SecureCameraActivity" />
        <activity
            android:name=".ui.conversation.ConversationDetailActivity"
            android:exported="false"
            android:launchMode="standard"
            android:theme="@style/AppThemeNoAction"
            android:windowSoftInputMode="stateHidden|adjustPan" />
        <activity
            android:name=".ui.conversation.StoryActivity"
            android:exported="false"
            android:launchMode="standard"
            android:theme="@style/AppThemeNoAction"
            android:windowSoftInputMode="stateHidden|adjustPan" />
        <activity
            android:name=".ui.conversation.AddUpdateMediaActivity"
            android:configChanges="keyboardHidden|orientation|screenSize"
            android:exported="false"
            android:theme="@style/AppThemeNoAction" />
        <activity
            android:name=".ui.stories.StoryGalleryActivity"
            android:exported="false"
            android:theme="@style/AppThemeNoAction"
            />
        <activity
            android:name=".ui.stories.StoryEditorActivity"
            android:exported="false" />
        <activity
            android:name=".ui.contacts.ContactListActivity"
            android:exported="false" />
        <activity
            android:name=".ui.gallery.GalleryActivity"
            android:exported="false"
            android:title="@string/photo_gallery" />
        <activity
            android:name=".ui.StickerActivity"
            android:exported="false"
            android:title="@string/action_stickers" />
        <activity
            android:name=".ui.ServicesActivity"
            android:exported="false"
            android:title="@string/action_services" />
        <activity
            android:name=".ui.PanicSetupActivity"
            android:label="@string/panic_trigger_app"
            android:theme="@style/AppThemeNoAction">
            <intent-filter>
                <action android:name="info.guardianproject.panic.action.CONNECT" />
                <action android:name="info.guardianproject.panic.action.DISCONNECT" />

                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>
        <activity
            android:name=".ui.contacts.ContactDisplayActivity"
            android:exported="false"
            android:theme="@style/AppThemeNoAction" />
        <activity
            android:name=".ui.contacts.GroupDisplayActivity"
            android:exported="false" />
        <activity
            android:name=".ui.contacts.DeviceDisplayActivity"
            android:exported="false" />
        <activity
            android:name=".ui.accounts.AccountsActivity"
            android:exported="false"
            android:label="@string/accounts" />

        <provider
            android:name="android.support.v4.content.FileProvider"
            android:authorities="${applicationId}.provider"
            android:exported="false"
            android:grantUriPermissions="true">
            <meta-data
                android:name="android.support.FILE_PROVIDER_PATHS"
                android:resource="@xml/provider_paths" />
        </provider>

        <activity
            android:name=".nearby.NearbyAddContactActivity"
            android:exported="false"
            android:label="@string/title_activity_nearby" />
        <activity
            android:name=".nearby.NearbyShareActivity"
            android:exported="false"
            android:label="@string/title_activity_nearby" />
        <activity
            android:name=".ui.camera.CameraActivity"
            android:exported="false"
            android:label="" />
    </application>

</manifest>
